<template>
  <div class="profile-container">
    <div class="profile">
      <div class="left">
        <div class="image">
          <img src="@/assets/camera.png" ref="img-container" alt="Person">
        </div>
        <div class="name">
          {{ currentUser.firstName }} {{ currentUser.lastName }}
        </div>
        <div class="menu">
          <div class="menu-item" :class="{'menu-item--active': item === currentWindow}" v-for="(item, index) in Object.keys(mapKeyComponent)" :key="index" @click="setWindow(item)">
            <div>{{ mapKeyComponent[item].title }}</div>
          </div>
        </div>
      </div>
      <div class="right">
        <component :is="mapKeyComponent[currentWindow].component"></component>
      </div>
    </div>
  </div>
</template>
<script>
import { PROFILE } from '@/store/types'
import { mapGetters } from 'vuex'
import axios from 'axios'
import ProfileAboutMe from '@/components/profile/ProfileAboutMe'
import ProfileMyEvents from '@/components/profile/ProfileMyEvents'
import ProfileFriends from '@/components/profile/ProfileFriends'
export default {
  name: 'Profile',
  data: () => ({
    mapKeyComponent: {
      'about-me': {
        title: 'About me',
        component: ProfileAboutMe
      },
      'my-events': {
        title: 'My events',
        component: ProfileMyEvents
      },
      profile: {
        title: 'Friends',
        component: ProfileFriends
      }
    },
    currentWindow: 'about-me'
  }),
  mounted () {
    const self = this
    axios.get(`http://localhost:9192/image/get/${this.currentUser.imageName}`, {
      // responseType: 'blob'
    }).then(response => {
      var blob = response.data.picture
      const imageUrl = `data:image/png;base64,${blob}`
      self.$refs['img-container'].src = imageUrl
    }).catch(err => {
      console.error('error loading image', err)
      self.$refs['img-container'].src = require(`@/assets/camera.png`)
    })
  },
  computed: {
    ...mapGetters({
      currentUser: PROFILE.GETTER.GET_USER_DATA
    })
  },
  watch: {
    currentUser (crntU, oldU) {
      if (crntU.imageName === oldU.imageName) return
      const self = this
      axios.get(`http://localhost:9192/image/get/${this.currentUser.imageName}`, {
        // responseType: 'blob'
      }).then(response => {
        var blob = response.data.picture
        const imageUrl = `data:image/png;base64,${blob}`
        self.$refs['img-container'].src = imageUrl
      }).catch(err => {
        console.error('error loading image', err)
        self.$refs['img-container'].src = require(`@/assets/camera.png`)
      })
    }
  },
  methods: {
    setWindow (window) {
      this.currentWindow = window
    }
  }
}
</script>
<style lang="scss" scoped>
.profile-container {
  display: flex;
  justify-content: center;
  margin-top: 30px;

  .profile {
    max-width: 1200px;
    width: 100%;
    display: flex;
    justify-content: space-between;
  }

  .left {
    max-width: 400px;
    width: 100%;
    display: flex;
    flex-direction: column;
    align-items: center;

    .image {
      width: 115px;
      height: 115px;
      border-radius: 50%;
      overflow: hidden;
      margin-bottom: 20px;
      & img {
        width: 100%;
        height: 100%;
        object-fit: cover;
      }
    }

    .name {
      font-weight: 600;
      font-size: 18px;
      margin-bottom: 35px;
    }

    .menu {
      width: 100%;
      display: flex;
      flex-direction: column;
      align-items: center;

      .menu-item {
        font-size: 18px;
        padding: 10px 35px;
        box-sizing: border-box;
        max-width: 300px;
        width: 100%;
        text-align: start;
        cursor: pointer;
        &--active {
          background: #EFF0F0;
        }
      }
    }
  }
  .right {
    max-width: 700px;
    width: 100%;
  }
}
</style>
